#ifndef COURSE_H
#define COURSE_H

#include <imgui.h>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <vector>
class Course {
  public:
    std::string number;
    std::string name;
    std::string desc;
    std::vector<std::vector<std::string>> prereq;
    Course(std::string in);
};

class CourseWindow {
  public:
    bool Open = true;
    bool Focused = false;
    std::string new_course_string;
    bool link_pressed = false;
    Course course;
    ImVec2 window_pos;
    ImVec2 window_size;
    CourseWindow(Course in_course);
    void Show();
};

class CourseManager {
  public:
    std::unordered_map<std::string, CourseWindow> course_windows;
    std::unordered_map<std::string, Course> all_courses;
    CourseManager(std::unordered_map<std::string, Course> ac);
    void Draw(void);
    void AddByNum(std::string num);
    void DrawLines(void);
};

#endif
